/*
	lamps.h
*/
#ifndef __LAMPS_H
#define __LAMPS_H
#include "comm.h"

#define		MAX_DIMMABLE	40

typedef struct
{
	BOOL on;		// turn on/off
	int lamp;		// lamp index
} LAMP;

typedef struct
{
	int count;			// number of lamps
	int delay;			// delay in ms
	LAMP	*lamps;	// lamp array
} LAMP_SEQ;

typedef struct
{
	int count;			// number of sequences
	int rep;			// repeat count for this lamp group
	LAMP_SEQ *lamp_seqs;	// lamp sequences
} LAMP_GROUP;

typedef struct
{
	int count;		// lamp groups in this program
	int PatternNdx;
	int LampNdx;
	int RepeatCnt;
	int NextDelay;
	int CurrentDelay;
	LAMP_GROUP *lamp_groups;	// array of lamp sequences
} LAMP_PROGRAM;

typedef struct
{
	int count;			// number of lamp programs
	BOOL Running;		// this program is running
	BOOL Dimmed;		// running dimmed
	int Priority;		// running priority of this program
	int lampCnt;		// total lamps used by this program all groups
	BOOL LampEn[OUT_COUNT];	// used for priority
	BOOL LampList[OUT_COUNT];	// list of all lamps in all groups
	LAMP_PROGRAM *lamp_programs;	// array of lamp programs
} PROGRAM;

typedef struct
{
	int count;
	int frontLamps;
	int rearLamps;
	int dimCount;
	BOOL dimmable[MAX_DIMMABLE];
	PROGRAM *progs;		// array of programs
} PROG_LIST;

typedef struct
{
	int ProgIndex;		// program number
	int Priority;
	BOOL Dimmed;
	int Level;
} PROG_INPUT;		// program from input 

extern PROG_LIST Programs;
extern PROG_INPUT *ProgInputs;		// program inputs for stand-alone bar

void LampInit(void);
void StopProgram(int pgm);
BOOL StartProgram(int pgm, int pri, BOOL dim);

#endif
