/*
	sound.h
*/

// tri-state input typedef
typedef enum _DEVICE { NO_DEVICE = 0, WAVE_DEVICE, MIC_DEVICE, RADIO_DEVICE, STANDBY_DEVICE, MANUAL_DEVICE } DEVICE;

#define		SIREN_OFF				0
#define		TIME_TO_CHANGE_TONE		12000
#define		MODE_RADIO				0
#define		MODE_MULTITONE			1				
#define		RADIO					1
#define		WAIL					2
#define		YELP					3
#define		STINGER					4
#define		HI_LO					5

extern BOOL AirHornBit[2];
extern BOOL ManualBit[2];
extern BOOL ManualStop[2];
extern BOOL ManualStart[2];
extern int SirenControl[2];
extern int toneMode[2];
extern BOOL StandByMode;
extern int StandByTone;
extern BOOL HornRingOn;

void SoundInit();
void SelectDevice(int ndx, DEVICE dev);
void Siren(int ndx, BOOL on);
void CancelStandbyTone(int ndx, BOOL kill);
void SoundTasks();


