/*
	beepalert.c handle beep alert logic
*/
#define _SUPPRESS_PLIB_WARNING 1 

#include "GenericTypeDefs.h"
#include "HardwareProfile.h"
#include "timer.h"
#include "beepalert.h"
#include "logic.h"

volatile int _buzzer = 0;

static int state;
static int tick;
static int actTick;
static int beepTick;
static BOOL anyActive;
// beep alert time outs
static int timeOuts[] = { 30000, 60000, 120000, 180000, 300000 };
 
void BeepAlertInit()
{
	BUZZ_TRIS = 0;
	BUZZER = 0;
	state = 0;
	anyActive = FALSE;
	tick = GetTickCount();
}

void Buzzer(int tim)
{
	_buzzer = tim;
	BUZZER = 1;		// buzzer on
}

static void ActiveCheck()
{
	int key, tim;
	BOOL act;

	act = FALSE;
	for(key = 0; key < KEY_COUNT; key++)
		if (TouchPad.KeyData[key].Active)
		{
			act = TRUE;
			break;
		}
	if (! act)
		for(key = 1; key < SLIDE_COUNT; key++)
			if (TouchPad.SlideData[key].Active)
			{
				act = TRUE;
				break;
			}
	// active change?
	if (anyActive != act)
		actTick = GetTickCount();
	else
	{
		// if we're active, check the timeout
		if (act)
		{
			if (HasElapsed(actTick, timeOuts[TouchPad.BeepAlert - 1]))
			{
				Buzzer(50);
				state = 1;
			}
		}
	}
	anyActive = act;
}

void BeepAlertTasks()
{

	if (Repeat(&tick, 1000))		// every second
	{
		
		if (ValidTouchPad())
		{
			if (TouchPad.BeepAlert > 0)		// is it turned on?
			{
				switch(state)
				{
					case 0:
						ActiveCheck();
						break;
					case 1:
						Buzzer(50);
						state++;
						break;
					case 2:
						Buzzer(50);
						state = 0;
						actTick = GetTickCount();
						break;
				}
			}
		}
	}
}
