/*
	switches.c
*/
#include "GenericTypeDefs.h"
#include "HardwareProfile.h"
#include "logic.h"

#define	MAX_NAME_LEN	40
/* this touch pads personality */
#define	EXP_CARDS		2
#define	ANALOG_CARDS	3
#define	SWITCH_COUNT	18
#define	SLIDE_COUNT		4
#define	INPUT_COUNT		5
#define	OUTPUT_COUNT	20
#define	EXP_OUTPUTS		10

enum OutState
{
	None,
	On,
	Off
};

typedef struct
{
	int SwitchType;	// 0-momentary, 1-toggle, 2-timer
	int TimerValue;
	BOOL Enabled;
	BOOL WarningTone;	// play warning tone if on too long
	int SirenTone;		// zero is none
	double VoltSetpoint;
	BOOL VoltActiveAbove;
	double TempSetpoint;
	BOOL TempActiveAbove;

	enum OutState Buttons[SWITCH_COUNT];
	enum OutState Outputs[OUTPUT_COUNT];
	enum OutState OutExp1[EXP_OUTPUTS];
	enum OutState OutExp2[EXP_OUTPUTS];
} INPUT_DATA;

typedef struct
{
	char Name[MAX_NAME_LEN + 1];
	char TPName[MAX_NAME_LEN + 1];
	char LBName[MAX_NAME_LEN + 1];
	BOOL Exp[EXP_CARDS];
	BOOL Analog[ANALOG_CARDS];
	BOOL TempC;

	INPUT_DATA SwitchData[SWITCH_COUNT];
	INPUT_DATA SlideData[SLIDE_COUNT];
	INPUT_DATA InputData[INPUT_COUNT];
	INPUT_DATA AnalogData[ANALOG_CARDS];
} TOUCHPAD;

extern TOUCHPAD TouchPad;
